/*
 * Gtk-IPtables is Copyright (C) 2006  Daniel E. Testa
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef MAIN_H
#define MAIN_H

#include <gtk/gtk.h> 
#include <stdio.h>
#include <stdlib.h>    
#include <string.h>
#include <ctype.h>

#include "gtkipt_utils.h"

#define STR_APP_TITLE   "Gtk-IPTables (FrontEnd) v0.5.1"

#define FILTER_INPUT    "Filter -> INPUT"
#define FILTER_FORWARD  "Filter -> FORWARD"
#define FILTER_OUTPUT   "Filter -> OUTPUT"

#define NAT_PREROUTING  "Nat -> PREROUTING"
#define NAT_POSTROUTING	"Nat -> POSTROUTING"
#define NAT_OUTPUT	"Nat -> OUTPUT"

#define MANGLE_PREROUTING  "Mangle -> PREROUTING"
#define MANGLE_OUTPUT	   "Mangle -> OUTPUT"
#define MANGLE_INPUT	   "Mangle -> INPUT"
#define MANGLE_FORWARD	   "Mangle -> FORWARD"
#define MANGLE_POSTROUTING "Mangle -> POSTROUTING"

#define LIST_COLS	11

#define ASCII_LF	0x0A
#define ASCII_CR	0x0D
#define ASCII_NUL	0x00
#define ASCII_SPACE	0x20

#define CREATE_INSERT 1
#define CREATE_ADD    2

extern void create_win(int n_op, int n_number);

/* functions */
void update_rules();
void get_rules(GtkWidget *pls_rules);
void bypass_lines(FILE *p_file, int n_lines);

/* callbacks */
gint on_delete_wnd_event(GtkWidget *widget, GdkEvent *event, gpointer data);
void on_bt_exit_clicked(GtkWidget *widget, gpointer data);
void on_bt_about_clicked(GtkWidget *widget, gpointer data);
void on_bt_del_clicked(GtkWidget *widget, gpointer data);
void on_bt_insert_clicked(GtkWidget *widget, gpointer data);
void on_bt_add_clicked(GtkWidget *widget, gpointer data);
void on_cb_tables_changed(GtkWidget *widget, gpointer data);
void on_ls_rules_select_row(GtkWidget *widget, gint row, gint column, 
			    GdkEventButton *event, gpointer data);

#endif /* MAIN_H */
